/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeVersion;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_InsurancePayor;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_InsurancePayor;


/**
 * This class represents InsurancePayor - CID3730
 */
public class InsurancePayor_CID3730 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The Coding Scheme Version
	 */
	private String strCodingSchemeVersion = null;

	/**
	 * Instantiates a new InsurancePayor_CID3730 Template.
	 */
	public InsurancePayor_CID3730() 
	{

	}

	/**
	 * Retrieves the value for CodeMeaning
	 * @return strCodeMeaning String value for CodeMeaning
	 */
	public String getCodeMeaning() 
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for CodeValue
	 * @return strCodeValue String value for CodeValue
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for CodingSchemeDesignator
	 * @return strCodingSchemeDesignator String value for CodingSchemeDesignator
	 */
	public String getCodingSchemeDesignator()
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Retrieves the value for CodingSchemeVersion
	 * @return String - value of Coding Scheme Version
	 */
	public String getCodingSchemeVersion() {
		return strCodingSchemeVersion;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumInsurancePayor Object of EnumCM_InsurancePayor represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_InsurancePayor enumInsurancePayor)
	{
		switch(enumInsurancePayor)
		{
		case COMMERCIAL:
			this.strCodeValue = EnumCV_InsurancePayor.COMMERCIAL_18_2.getValue();
			break;
		case GOVERNMENT:
			this.strCodeValue = EnumCV_InsurancePayor.GOVERNMENT_18_1.getValue();
			break;
		case HEALTH_MAINTENANCE_ORGANIZATION:
			this.strCodeValue = EnumCV_InsurancePayor.HEALTH_MAINTENANCE_ORGANIZATION_18_3.getValue();
			break;
		case NONE:
			this.strCodeValue = EnumCV_InsurancePayor.NONE_18_4.getValue();
			break;
		}
	}

	/**
	 * Sets the value for InsurancePayor
	 * @param enumInsurancePayor Enum for InsurancePayor
	 */
	public void setInsurancePayor(EnumCM_InsurancePayor enumInsurancePayor)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumInsurancePayor.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.NCDR.getValue();
		this.strCodingSchemeVersion = EnumCodingSchemeVersion.CSV_2_0b.getValue();
			
		/**
		 * set code Value
		 */
		setCodeValue(enumInsurancePayor);
	}
}
